if not vademon.home then vademon.home = {} end
vademon.home.chat = {}
vademon.home.chat.commandList = {}
vademon.home.func = {}
if not vademon.home.list then vademon.home.list= {} end
--[[
vademon.home.list = {
	[1] = xCoordinate
	[2] = yCoordinate
	[3] = {[usgn] = true, [usgn] = true ...} -- list of invited people
	[4] = {[usgn]=true,...} -- list of homes the player is invited to
}
]]

vademon.home.chat.commandName = "!home"

addhook("say","vademon.home.chat.processor")
addhook("minute","vademon.home.func.saveHomeList")

function vademon.home.chat.processor(id, txt)
	if txt:sub(1, 1) ~= "!" then
		return 0
	end

	local firstSpace = string.find(txt, " ")
		
	if firstSpace then 
		firstSpace = firstSpace - 1 
	elseif string.lower(txt:sub(1, #vademon.home.chat.commandName)) == vademon.home.chat.commandName then
		vademon.home.func.sweetHome(id)
		return 1
	else
		return 0
	end

	if txt:sub(1, firstSpace) == vademon.home.chat.commandName then

		local delimeter = "%S+"
		local argList = vademon.home.chat.tokenize(txt, delimeter)
		
		if vademon.home.chat.commandList[ argList[2] ] then
		
			vademon.home.chat.commandList[ argList[2] ]( id, argList )
			return 1
		else
			msg2(id, "255085085Command '" .. argList[2] .. "' doesn't exist!")
			return 0
		end
	else

		return 0
	end
end

function vademon.home.chat.addCommand(command, alias, func)
	vademon.home.chat.commandList[ command ] = func
	if alias ~= "" then
		vademon.home.chat.commandList[ alias ] = vademon.home.chat.commandList[ command ]
	end
end


function vademon.home.chat.tokenize(str, delimeter)
	local wordList = {}
	local tempStr = ""
	local concatenateThis = false
	
	for word in str:gmatch(delimeter) do
		local char = word:sub(1,1)
		if char == "'" or char == '"' then
			concatenateSuccessor = true
			tempStr = word
		else
			if concatenateSuccessor then
				tempStr = tempStr .. " " .. word
				local char = word:sub(-1,-1)
				if char == "'" or char == '"' then
					wordList[ #wordList + 1 ] = tempStr
					tempStr = ""
					concatenateSuccessor = false
				end
			else
				wordList[ #wordList + 1 ] = word
			end
		end
	end
	
	return wordList
end

------
vademon.home.func.serialize = dofile("sys/lua/vademon/serialize/serialize.lua")

function vademon.home.func.getInvitedPlayers( list )
	local str = "USGNs: "

	for k, _ in list do
		str = str .. k .. ", "
	end
	
	return str:sub(1,-2)
end

-- bool, int tilex, int tiley
function vademon.home.func.isHomeSet( usgn )
	if vademon.home.list[ usgn ] then
		local x, y = vademon.home.list[ usgn ][1], vademon.home.list[ usgn ][2]
		
		if x == 0 and y == 0 then
			return false, 0, 0
		else
			return true, x * 32 + 15, y * 32 +15
		end
		
		return false, 0, 0
	end
end

function vademon.home.func.sweetHome(id)
	local usgn = player(id, "usgn")
	if usgn ~= 0 then
		local state, x, y = vademon.home.func.isHomeSet( usgn ) 
						
		if state then
			parse("setpos " .. id .. " " .. x .. " " .. y)
			msg2(id, "030220200Welcome back home!")
		else
			msg2(id, "255085085You have not set a home yet!")
			msg2(id, "255085085Use '!home set' to set your own home!")
		end
	else
		msg2(id, "255085085You must be logged into USGN to use homes!")
	end
end

function vademon.home.func.saveHomeList()
	local strList = vademon.home.func.serialize("if not vademon then vademon = {home={list={}}} end\n".."vademon.home.list", vademon.home.list)
	
	local file = io.open("sys/lua/autorun/vademon_home_list.lua", "w")
	file:write(strList)
	file:close()
	print("[HOME] Home list saved!")
end

------

local function setHome(id)
	local usgn = player(id, "usgn")
	if usgn ~= 0 then
		if not vademon.home.list[ usgn ] then
			vademon.home.list[ usgn ] = {}
		end
		
		vademon.home.list[ usgn ][1] = player(id, "tilex")
		vademon.home.list[ usgn ][2] = player(id, "tiley")
		vademon.home.list[ usgn ][3] = {}
		vademon.home.list[ usgn ][4] = {}
		msg2(id, "255160000Your home was set to your position! (" ..player(id, "tilex").. ","..player(id, "tilex")..")")
		
		return 1
	else
		msg2(id, "255085085You must be logged into USGN to set your home position!")
	end
end
vademon.home.chat.addCommand("set", "", setHome)

local function deleteHome(id)
	local usgn = player(id, "usgn")
	if usgn ~= 0 then
		if vademon.home.list[ usgn ] then
			--[[delete entries from invited players' homes
			for _, v in pairs(vademon.home.list[usgn][3]) do 
				if vademon.home.list[v] then
					vademon.home.list[v][4][usgn] = nil
				end
			end
			
			-- delete entries from homes the player is invited to
			for _, v in pairs(vademon.home.list[usgn][4]) do 
				if vademon.home.list[v] then
					vademon.home.list[v][3][usgn] = nil
				end
			end]]
			vademon.home.list[ usgn ][1] = 0
			vademon.home.list[ usgn ][2] = 0
			
		end
		msg2(id, "255160000You deleted your sweet home :'(")

		
		return 1
	else
		msg2(id, "255085085You must be logged into USGN to delete your home position!")
	end
end
vademon.home.chat.addCommand("delete", "", deleteHome)

local function invite(id, argList)
	local usgn = player(id, "usgn")
	friendUsgn = tonumber( argList[3] )
	
	if usgn ~= 0 then
		if vademon.home.list[ usgn ] then
			if friendUsgn and friendUsgn ~= 0 then
				if vademon.home.list[ friendUsgn ] then
					vademon.home.list[ usgn ][3][ friendUsgn ] = true
					vademon.home.list[ friendUsgn ][4][ usgn ] = true
					
					msg2(id,"255160000You have invited your friend! He/She can use '/home "..usgn.."' to visit your home!")
				else
					-- only shows how much this script suxx
					msg2(id, "255085085Your friend doesn't have a home yet. You can't invite him, sorry!")
				end
			else
				msg2(id, "255085085Apparently, your friend MUST HAVE USGN in order for you to invite him")
			end
		else
			msg2(id, "255085085You must set a home first! Type in '!home set'")
		end
	else
		msg2(id, "255085085You must be logged into USGN to invite players!")
	end
	
	return 1
end
vademon.home.chat.addCommand("invite", "", invite)

local function uninvite(id, argList)
	local usgn = player(id, "usgn")
	friendUsgn = tonumber( argList[3] )
	
	if usgn ~= 0 then
		if vademon.home.list[ usgn ] then
			if friendUsgn and friendUsgn ~= 0 then
				if vademon.home.list[ friendUsgn ] then
					vademon.home.list[ usgn ][3][ friendUsgn ] = nil
					vademon.home.list[ friendUsgn ][4][ usgn ] = nil
					
					msg2(id,"255160000You have uninvited a player with USGN #" .. friendUsgn)
				else
					-- only shows how much this script suxx
					msg2(id, "255085085This user doesn't have a home yet. You can't invite him, sorry!")
				end
			else
				msg2(id, "255085085Apparently, this user MUST HAVE USGN in order for you to uninvite him")
			end
		else
			msg2(id, "255085085You must set a home first! Type in '!home set'")
		end
	else
		msg2(id, "255085085You must be logged into USGN to uninvite players!")
	end
	
	return 1
end
vademon.home.chat.addCommand("uninvite", "", uninvite)

local function list(id)
	local usgn = player(id, "usgn")

	if usgn ~= 0 then
		if vademon.home.list[ usgn ] then
			msg2(id, "030220200You are invited to homes of:")
			msg2(id, "030220200" .. vademon.home.func.getInvitedPlayers( vademon.home.list[ usgn ][3] ))			
				
		else
			msg2(id, "255085085You must set a home first! Type in '!home set'")
		end
	else
		msg2(id, "255085085You must be logged into USGN to see the invitations list!")
	end

	return 1
end
vademon.home.chat.addCommand("list", "", list)

local function ilist(id)
	local usgn = player(id, "usgn")

	if usgn ~= 0 then
		if vademon.home.list[ usgn ] then
			msg2(id, "030220200These players are invited to your home:")
			msg2(id, "030220200" .. vademon.home.func.getInvitedPlayers( vademon.home.list[ usgn ][4] ))			
				
		else
			msg2(id, "255085085You must set a home first! Type in '!home set'")
		end
	else
		msg2(id, "255085085You must be logged into USGN to see the invitations list!")
	end
	
end
vademon.home.chat.addCommand("ilist", "", ilist)

local function visit(id, argList)
	local usgn = player(id, "usgn")
	local target = argList[3]
	
	if target then
		if target:sub(1,3) == "id:" then
			local targetID = tonumber(target:sub(4))
			local targetUsgn = player(targetID, "usgn")
			
			if player(targetID, "exists") then
				if targetUsgn ~= 0 then
					local state, x, y = vademon.home.func.isHomeSet( targetUsgn ) 
					
					if state then
						if vademon.home.list[ targetUsgn ][3][ usgn ] then -- you can visit homes w/o USGN login if #0 is invited
							parse("setpos " .. id .. " " .. x .. " " .. y)
							msg2(id, "030220200Welcome to " .. player(targetID, "name") .."'s home!")
						else
							msg2(id, "255085085You are not invited to this home!")
						end
					else
						msg2(id, "255085085" .. player(targetID, "name") .. " hasn't set his home yet!")
					end
				else
					msg2(id, "255085085" .. player(targetID, "name") .. " is not logged into USGN!")
				end
			else
				msg2(id, "255085085Player with ID " .. targetID .. " is not online!")
			end
			
		else
			local targetUsgn = tonumber(target)
			if targetUsgn then
				if targetUsgn ~= 0 then
					local state, x, y = vademon.home.func.isHomeSet( targetUsgn ) 
					
					if state then
						if vademon.home.list[ targetUsgn ][3][ usgn ] then -- you can visit homes w/o USGN login if #0 is invited
							parse("setpos " .. id .. " " .. x .. " " .. y)
							msg2(id, "030220200Welcome to #" .. targetUsgn .. "'s home!")
						else
							msg2(id, "255085085You are not invited to this home!")
						end
					else
						msg2(id, "255085085#" .. targetUsgn .. " hasn't set his home yet!")
					end
					
				else
					msg2(id, "255085085You cannot visit #0's home!")
				end
			else
				msg2(id, "255085085You must specify a player to visit his home!")
			end
		end
	else
		msg2(id, "255085085You must specify a player to visit his home!")
	end
	
end
vademon.home.chat.addCommand("visit", "tp", visit)